{
    Copyright (C) 2000-2008 Benito van der Zander, www.benibela.de

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, StdCtrls, ImgList;
type htyp=(non,hq,energie,hub,pan,Mela,mauer);
type THaus=record
  Typ:htyp;
  x,y,xx,yy:integer;
  lieb:boolean;
  nummer:byte;
  zeug,an1:byte;
  zeugstatus:byte;
  delx,dely ,delxx,delyy:integer;
end;

type Trob=record
  Typ:(no,arrob,lpan,lheli);
  nummer:byte;
  lx,ly,x,y,xx,yy,ox,oy:integer;
  bild:TBitmap;
  aktiv,bumbum:boolean;
  delx,dely,delxx,delyy:integer;
  ziel,tmp:integer;
  lieb:boolean;
end;

type
  TForm1 = class(TForm)
    Image1: TImage;
    PaintBox1: TPaintBox;
    Image2: TImage;
    Shape1: TShape;
    Panel1: TPanel;
    Label1: TLabel;
    Image3: TImage;
    Timer1: TTimer;
    Label2: TLabel;
    Timer2: TTimer;
    Image4: TImage;
    Image5: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Image6: TImage;
    Image7: TImage;
    Label3: TLabel;
    Image8: TImage;
    Memo1: TMemo;
    Image9: TImage;
    ImageList1: TImageList;
    ImageList2: TImageList;
    animate: TTimer;
    Image10: TImage;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Image3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer2Timer(Sender: TObject);
    procedure animateTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen}
    procedure akt;
    procedure bauen(x,y,num,pos:integer;typ:htyp;bild:TBitmap);
    procedure zeugen(x,y,num,pos:integer;typ:htyp);
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;
  xx,yy:integer;

 Pfad:string;
 z:byte;
  bauten:array[1..250]of THaus;
  einheiten:array[1..200]of Trob;
  bbauten:array[1..250]of THaus;
  beinheiten:array[1..200]of Trob;
  haus:array[1..20]of Tbitmap;
  stein:array[1..3]of TPoint;

elemente:array[1..20]of TBitmap;
bau:array[1..20]of Tbitmap;
boden:tbitmap;
ein,hause:integer;
bein,bhause:integer;
 ia,delo:boolean;
implementation

{$R *.DFM}
{$R CURSOR.RES}

procedure TForm1.zeugen (x,y,num,pos:integer;tyP:htyp);

begin


bauten[pos].Typ:=typ;;
bauten[pos].nummer:=num;
bauten[pos].x:=x;
bauten[pos].y:=y;
bauten[pos].xx:=x + haus[num].Width;
bauten[pos].yy:=y + haus[num].Height;

end;

procedure TForm1.bauen (x,y,num,pos:integer;tyP:htyp;bild:TBitmap);
var b:integer;
begin
b:=pos;
    bauten[b].Typ:=typ;
    bauten[b].x:=x;
    bauten[b].y:=y;
    bauten[b].xx:=x + bild.Width;
    bauten[b].yy:=y + bild.Height;
    bauten[b].nummer:=num;
image2.Picture.Bitmap.Width:=bild.Width+1;
image2.Picture.Bitmap.Height:=bild.Height+1;
image2.Canvas.draw(0,0,bild);
Image2.Left:=bauten[b].x;
Image2.top:=bauten[b].y  ;
image1.Canvas.draw(bauten[b].x,bauten[b].y,Image2.Picture.Graphic );
akt;
end;


procedure TForm1.akt ();
var a,c:integer;
begin

      for c:= 1 to ein do begin
      einheiten[c].delx:=0;
      einheiten[c].dely:=0;
      einheiten[c].delxx:=0;
      einheiten[c].delyy:=0;
      end;
      for c:= 1 to hause do begin
       bauten[c].delx:=0;
       bauten[c].dely:=0;
       bauten[c].delxx:=0;
       bauten[c].delyy:=0;
      end;

    Image1.Canvas.Draw(0,0,boden);

    for a:=1to 3 do begin
image2.Picture.Bitmap.Width:=elemente[2].Width+1;
image2.Picture.Bitmap.Height:=elemente[2].Height+1;
image2.Canvas.draw(0,0,elemente[2]);
Image2.Left:=Stein[a].x;
Image2.top:=Stein[a].y  ;
image1.Canvas.Draw(Stein[a].x,Stein[a].y,image2.Picture.Graphic);
end;




for a:=1 to hause do
if bauten[a].nummer <>0 then begin
image2.Picture.Bitmap.Width:=haus[bauten[a].nummer].Width+1;
image2.Picture.Bitmap.Height:=haus[bauten[a].nummer].Height+1;
image2.Canvas.draw(0,0,haus[bauten[a].nummer]);
Image2.Left:=bauten[a].x;
Image2.top:=bauten[a].y ;

image1.Canvas.draw(bauten[a].x,bauten[a].y,image2.Picture.Bitmap);
end;

for a:=1 to ein do
if einheiten[a].nummer <>0 then
  imagelist1.draw(image1.Canvas, einheiten[a].x,einheiten[a].y,einheiten[a].nummer-1);








            Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var ox,oy:integer;
  begin

  ox:=xx;
  oy:=yy;
if key=vk_F5 then   akt;
if key=vk_left then dec(xx,10);
if key=vk_right then inc(xx,10);
if key=vk_up then dec(yy,10);
if key=vk_down then inc(yy,10);
if (xx<PaintBox1.Width- Image1.Picture.Width)or(xx>0) then xx:=ox;
if (yy<PaintBox1.Height- Image1.Picture.Height)or(yy>0) then yy:=oy;
Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.bitmap);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var a,b,unter:integer;
    inbum:boolean;
begin
//image1.Canvas.MoveTo(ABS(xx)+x,ABS(yy)+y);
if button = mbLeft then begin
               Label2.Caption := '';;
              for a:=1 to 50 do
               bauten[a].an1:=0;
if PaintBox1.tag= 0 then begin
    if Image3.Tag <> 0 then begin
    Image3.Canvas.Rectangle(-2,-2,200,200);
    Image3.tag:=0;
    end;
    if Image6.Tag <> 0 then begin
    Image6.Canvas.Rectangle(-2,-2,200,200);
    Image6.tag:=0;
    end;
    if Image7.Tag <> 0 then begin
    Image7.Canvas.Rectangle(-2,-2,200,200);
    Image7.tag:=0;
    end;
    if Image8.Tag <> 0 then begin
    Image8.Canvas.Rectangle(-2,-2,200,200);
    Image8.tag:=0;
    end;
     if Image9.Tag <> 0 then begin
    Image9.Canvas.Rectangle(-2,-2,200,200);
    Image9.tag:=0;
    end;
     if Image10.Tag <> 0 then begin
    Image10.Canvas.Rectangle(-2,-2,200,200);
    Image10.tag:=0;
    end;

if not( ssShift in shift )then
for a:=1 to ein do
einheiten[a].aktiv:=false;
        Image1.Canvas.pen.Mode:=pmNot;
        Image1.Canvas.brush.Style:=bsClear;
if not( ssShift in shift )then
        for b:=1 to ein do
        Image1.Canvas.Rectangle(einheiten[b].delx,einheiten[b].dely,einheiten[b].delxx,einheiten[b].delyy);
         for b:=1 to hause do
        Image1.Canvas.Rectangle(bauten[b].delx,bauten[b].dely,bauten[b].delxx,bauten[b].delyy);
        Image1.Canvas.pen.Mode:=pmCopy;
        for b:=1 to ein do begin
                      einheiten[b].delx:=0;
              einheiten[b].dely:=0;
              einheiten[b].delxx:=0;

              einheiten[b].delyy:=0;
              end;
        for b:=1 to hause do begin
                      bauten[b].delx:=0;
              bauten[b].dely:=0;
              bauten[b].delxx:=0;

              bauten[b].delyy:=0;
              end;
              end;
        Label1.Caption:='';
            Label2.Caption:='';
 ia:=false;

if PaintBox1.Tag =  0 then begin

for a:=1 to ein do
if (ABS(xx)+x>einheiten[a].x) and (ABS(xx)+x<einheiten[a].xx)and
      (ABS(yy)+y>einheiten[a].y) and (ABS(yy)+y<einheiten[a].yy) then begin

        if einheiten[a].Typ =lheli then
          Label1.Caption:='Leichter Hubschrauber';
          if einheiten[a].Typ =lpan then
          Label1.Caption:='Leichter Panzer';
        if einheiten[a].Typ =arrob then begin
          Label1.Caption:='Arbeitsroboter';
          imaGE3.Canvas.Draw(1,1,bau[1]);
            image3.Tag:=2;
          imaGE6.Canvas.Draw(1,1,bau[2]);
            image6.Tag:=3;
          imaGE7.Canvas.Draw(1,1,bau[3]);
            image7.Tag:=4;
          imaGE8.Canvas.Draw(1,1,bau[4]);
            image8.Tag:=5;
          imaGE9.Canvas.Draw(1,1,bau[5]);
            image9.Tag:=6;
          imaGE10.Canvas.Draw(-5,-5,bau[6]);
            image10.Tag:=7;
        end;
        Image1.Canvas.pen.Mode:=pmNot;
        ia:=true;
              einheiten[a].aktiv :=true;

        Image1.Canvas.pen.Mode:=pmNot;
        Image1.Canvas.brush.Style:=bsClear;
        Image1.Canvas.Rectangle(einheiten[a].x,einheiten[a].y,einheiten[a].xx,einheiten[a].yy);
        Image1.Canvas.pen.Mode:=pmCopy;
        einheiten[a].delx:=einheiten[a].x;
        einheiten[a].dely:=einheiten[a].y;
        einheiten[a].delxx:=einheiten[a].xx;
        einheiten[a].delyy:=einheiten[a].yy;
if not( ssShift in shift )then begin

        for b:=1 to 100 do
          if a<>b then einheiten[b].aktiv:=false;
      break;
        end;
      end;



for a:=1 to 50 do
if (ABS(xx)+x>bauten[a].x) and (ABS(xx)+x<bauten[a].xx)and
      (ABS(yy)+y>bauten[a].y) and (ABS(yy)+y<bauten[a].yy) then begin
        if bauten[a].Typ=hq then begin
        Label1.Caption:='Hauptquartier';
       imagelist1.Draw(image3.Canvas,0,0,0);
   image3.Tag:=1;
       imagelist1.Draw(image3.Canvas,0,0,0);
   image3.Tag:=1;
         image3.hint:=IntToStr(a);
if bauten[a].zeug =1 then
 bauten[a].an1:=1;
        end;
         if bauten[a].Typ=energie then begin
        Label1.Caption:='Kraftwerk';
 end;
         if bauten[a].Typ=pan then begin
        Label1.Caption:='Panzerwerk';
   imagelist1.Draw(image3.Canvas,0,0,
   1);
   image3.Tag:=20;
   if bauten[a].zeug =2 then
 bauten[a].an1:=2;
            image3.hint:=IntToStr(a);
 end;
         if bauten[a].Typ=mela then begin
        Label1.Caption:='Bergwerk';
end;
         if bauten[a].Typ=hub then begin
        Label1.Caption:='Hubschrauberwerk';

   imagelist1.Draw(image3.Canvas,0,0,2);
   image3.Tag:=30;
   if bauten[a].zeug =3 then
 bauten[a].an1:=3;
            image3.hint:=IntToStr(a);

end;
        Image1.Canvas.pen.Mode:=pmNot;
        Image1.Canvas.brush.Style:=bsClear;

        Image1.Canvas.Rectangle(bauten[a].x,bauten[a].y,bauten[a].xx,bauten[a].yy);
        Image1.Canvas.pen.Mode:=pmCopy;
        bauten[a].delx:=bauten[a].x;
        bauten[a].dely:=bauten[a].y;
        bauten[a].delxx:=bauten[a].xx;
        bauten[a].delyy:=bauten[a].yy;

      end;


      end else if PaintBox1.tag<>0 then begin
b:=   PaintBox1.tag;
      PaintBox1.tag:= 0;
      PaintBox1.Cursor:=crDefault;

      for a :=1 to 100 do
       if (einheiten[a].Typ=arrob) and (einheiten[a].aktiv=true) then begin
einheiten[a].lx :=ABS(xx-x);;

einheiten[a].ly :=ABS(yy-y);;
einheiten[a].ziel :=b;
exit;
       end;

      end ;






Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
      end

      else if button = mbRight then begin
            x:=Abs(xx)+x;
      y:=Abs(yy)+y;

      if ia= true then begin
      for a:=1 to 100 do begin
      if einheiten[a].aktiv=true then begin
      inbum:=false;

for b:= 1to BEIN do begin
if (beinheiten[b].x +30>x) and
      (beinheiten[b].x <x+3) and
          (beinheiten[b].y +30>y) and
             (beinheiten[b].y <y+3) then begin
                       inbum :=true;

                       break;
             end;
end;
einheiten[a].bumbum:=inbum;
      unter:=4;
      case  einheiten[a].Typ of


      lpan:unter:=5 ;
      arrob:unter:=4 ;
      lheli:unter:=8  ;
      end;

      einheiten[a].lx:=einheiten[a].lx - (einheiten[a].lx mod unter);
      einheiten[a].ly:=einheiten[a].ly - (einheiten[a].ly mod unter);
      einheiten[a].lx:=(x div unter)*unter;
      einheiten[a].ly:=(y div unter)*unter;
      end;

      end;
      akt;
//      einheiten[aktiv].nummer

      end
      end;

end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
{if ssleft in shift then
image1.Canvas.lineTo(ABS(xx)+x,ABS(yy)+y);}
z := z+1;
if (z div 20=0)ANd (z div 40<>0) then
Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
if z>=2000 then z:=0;
Label3.Caption:='';
Form1.caption:=IntToStr(xx)+' '+IntToStr(yy)+' '+IntToStr(x)+' '+IntToStr(y)+' ';
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Form1.caption:=IntToStr(xx)+' '+IntToStr(yy)+' '+IntToStr(x)+' '+IntToStr(y)+' ';
end;

procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//var a,b:byte;
var index:TImage;
begin
index:=Sender as TImage;
if index.Tag <>0then begin
case index.Tag of
1:
if (image4.Tag - 150>=0)and(image5.Tag - 100>=0) and (ein< 230) then begin
  image4.Tag:=image4.Tag - 150;
  image5.Tag:=image5.Tag - 100;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

  bauten[StrToInt(index.hint)].zeug:=1;
  bauten[StrToInt(index.hint)].an1:=  bauten[StrToInt(index.hint)].zeug;
end;

2:
if (image4.Tag -100>=0)and(image5.Tag - 300>=0)and(hause< 170) then begin
  image4.Tag:=image4.Tag - 100;
  image5.Tag:=image5.Tag - 300;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=100;
PaintBox1.Tag:=10;
end;
3:begin
if (image5.Tag - 400>=0) and(hause< 170)then begin

  image5.Tag:=image5.Tag - 400;

  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=101;
PaintBox1.Tag:=11;
end;
end;

4:
if (image4.Tag -190>=0)and(image5.Tag - 500>=0)and(hause< 170) then begin
  image4.Tag:=image4.Tag - 190;
  image5.Tag:=image5.Tag - 500;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=102;
PaintBox1.Tag:=12;
end;
5:
if (image4.Tag -210>=0)and(image5.Tag - 550>=0) and(hause< 170)then begin
  image4.Tag:=image4.Tag - 210;
  image5.Tag:=image5.Tag - 550;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=103;
PaintBox1.Tag:=13;
end;
6:
if (image4.Tag -200>=0)and(image5.Tag - 25>=0) and(hause< 170)then begin
  image4.Tag:=image4.Tag - 200;
  image5.Tag:=image5.Tag - 25;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=104;
PaintBox1.Tag:=14;
end;
7:
if (image4.Tag -10>=0)and(image5.Tag - 25>=0) and(hause< 170)then begin
  image4.Tag:=image4.Tag - 10;
  image5.Tag:=image5.Tag - 25;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

PaintBox1.Cursor:=105;
PaintBox1.Tag:=15;
end;
20:
if (image4.Tag - 200>=0)and(image5.Tag - 170>=0) and(ein< 230)then begin
  image4.Tag:=image4.Tag - 200;
  image5.Tag:=image5.Tag - 170;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

  bauten[StrToInt(index.hint)].zeug:=2;
  bauten[StrToInt(index.hint)].an1:=  bauten[StrToInt(index.hint)].zeug;
end;
30:
if (image4.Tag - 250>=0)and(image5.Tag - 220>=0) and(ein< 230)then begin
  image4.Tag:=image4.Tag - 250;
  image5.Tag:=image5.Tag - 220;
  Label4.Caption :=   inttostr(image4.tag);
  Label5.Caption :=   intTostr(image5.tag);

  bauten[StrToInt(index.hint)].zeug:=3;
  bauten[StrToInt(index.hint)].an1:=  bauten[StrToInt(index.hint)].zeug;
end;

end;
end;

Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var a,b,c,d,unter:byte;

   akto:boolean;
begin
akto:=false;
for a:=1 to ein do begin
      c:=einheiten[a].xx-einheiten[a].x;
      b:=einheiten[a].yy-einheiten[a].y;
      unter:=4;
      case  einheiten[a].Typ of


      lpan:unter:=5 ;
      arrob:unter:=4 ;
      lheli:unter:=8  ;
      end;

if ((einheiten[a].x div unter )*unter<>(einheiten[a].lx div unter )*unter)or
           ((einheiten[a].y div unter )*unter<>(einheiten[a].ly div unter )*unter) then begin
           akto:=true;
Image1.canvas.CopyRect(rect(einheiten[a].ox,einheiten[a].oy,einheiten[a].ox+30,einheiten[a].oy+30),
                einheiten[a].bild.canvas,
                rect(0,0,30,30));

einheiten[a].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(einheiten[a].x,einheiten[a].y,einheiten[a].x+30,einheiten[a].y+30));



if einheiten[a].typ=lheli then begin
einheiten[a].tmp:=einheiten[a].tmp+1;
if einheiten[a].tmp >1 then einheiten[a].tmp:=0;

imagelist1.draw(image1.Canvas, einheiten[a].x,
                 einheiten[a].y,2+einheiten[a].tmp);

end else
imagelist1.draw(image1.Canvas, einheiten[a].x,
                 einheiten[a].y,einheiten[a].nummer-1);

if einheiten[a].aktiv=true then begin
        Image1.Canvas.pen.Mode:=pmNot;
        Image1.Canvas.brush.Style:=bsClear;
        Image1.Canvas.Rectangle(einheiten[a].x,einheiten[a].y,einheiten[a].xx,einheiten[a].yy);
        einheiten[a].delx:=einheiten[a].x;
        einheiten[a].dely:=einheiten[a].y;
        einheiten[a].delxx:=einheiten[a].xx;
        einheiten[a].delyy:=einheiten[a].yy;

        Image1.Canvas.pen.Mode:=pmCopy;
end;



einheiten[a].ox:=einheiten[a].x;
einheiten[a].oy:=einheiten[a].y;

if einheiten[a].x<einheiten[a].lx then
  einheiten[a].x := einheiten[a].x +unter;
if einheiten[a].x>einheiten[a].lx then
  einheiten[a].x := einheiten[a].x -unter;
if einheiten[a].y<einheiten[a].ly then
  einheiten[a].y := einheiten[a].y +unter;
if einheiten[a].y>einheiten[a].ly then
  einheiten[a].y := einheiten[a].y -unter;


      einheiten[a].xx:=einheiten[a].x+c;
      einheiten[a].yy:=einheiten[a].y+b;
end;


end;



for a:=1 to bein do begin
      c:=beinheiten[a].xx-beinheiten[a].x;
      b:=beinheiten[a].yy-beinheiten[a].y;
      unter:=4;
      case  beinheiten[a].Typ of


      lpan:unter:=5 ;
      arrob:unter:=4 ;
      lheli:unter:=8  ;
      end;

if ((beinheiten[a].x div unter )*unter<>(beinheiten[a].lx div unter )*unter)or
           ((beinheiten[a].y div unter )*unter<>(beinheiten[a].ly div unter )*unter) then begin
           akto:=true;
Image1.canvas.CopyRect(rect(beinheiten[a].ox,beinheiten[a].oy,beinheiten[a].ox+30,beinheiten[a].oy+30),
                beinheiten[a].bild.canvas,
                rect(0,0,30,30));

beinheiten[a].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(beinheiten[a].x,beinheiten[a].y,beinheiten[a].x+30,beinheiten[a].y+30));



if beinheiten[a].typ=lheli then begin
beinheiten[a].tmp:=beinheiten[a].tmp+1;
if beinheiten[a].tmp >1 then beinheiten[a].tmp:=0;

imagelist1.draw(image1.Canvas, beinheiten[a].x,
                 beinheiten[a].y,2+beinheiten[a].tmp);

end else
imagelist1.draw(image1.Canvas, beinheiten[a].x,
                 beinheiten[a].y,beinheiten[a].nummer-1);

if beinheiten[a].aktiv=true then begin
        Image1.Canvas.pen.Mode:=pmNot;
        Image1.Canvas.brush.Style:=bsClear;
        Image1.Canvas.Rectangle(beinheiten[a].x,beinheiten[a].y,beinheiten[a].xx,beinheiten[a].yy);
        beinheiten[a].delx:=beinheiten[a].x;
        beinheiten[a].dely:=beinheiten[a].y;
        beinheiten[a].delxx:=beinheiten[a].xx;
        beinheiten[a].delyy:=beinheiten[a].yy;

        Image1.Canvas.pen.Mode:=pmCopy;
end;



beinheiten[a].ox:=beinheiten[a].x;
beinheiten[a].oy:=beinheiten[a].y;

if beinheiten[a].x<beinheiten[a].lx then
  beinheiten[a].x := beinheiten[a].x +unter;
if beinheiten[a].x>beinheiten[a].lx then
  beinheiten[a].x := beinheiten[a].x -unter;
if beinheiten[a].y<beinheiten[a].ly then
  beinheiten[a].y := beinheiten[a].y +unter;
if beinheiten[a].y>beinheiten[a].ly then
  beinheiten[a].y := beinheiten[a].y -unter;


      beinheiten[a].xx:=beinheiten[a].x+c;
      beinheiten[a].yy:=beinheiten[a].y+b;
end;

end;
if akto=true then             Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);

for d:=1 to hause do begin
if bauten[d].zeug<>0 then begin
   bauten[d].zeugstatus:=   bauten[d].zeugstatus+1;
if bauten[d].an1=1 then
      Label2.Caption := 'Arbeitsroboter: '+IntToStr(bauten[d].zeugstatus)+' %';;
if bauten[d].an1=2 then
      Label2.Caption := 'Leichter Panzer: '+IntToStr(bauten[d].zeugstatus)+' %';;
if bauten[d].an1=3 then
      Label2.Caption := 'Leichter Hubschrauber: '+IntToStr(bauten[d].zeugstatus)+' %';;
   if bauten[d].zeugstatus>=100 then begin
   Label2.Caption :='';
       b:=254;
          ein:=ein+1;

       for a:=1 to 100 do  begin
       if einheiten[a].Typ=no then begin
         b:=a;
         break;
         end;
      end;

    if b = 254 then begin
       bauten[d].zeugstatus:=0;
   bauten[d].zeug:=00;

exit;
end;
   if bauten[d].zeug=1 then begin
    einheiten[b].Typ:=arrob;
    einheiten[b].nummer:=1;
   end;
   if bauten[d].zeug=2 then begin
    einheiten[b].Typ:=lpan;
    einheiten[b].nummer:=2;
   end;
      if bauten[d].zeug=3 then begin
    einheiten[b].Typ:=lheli;
    einheiten[b].nummer:=3;
   end;
       bauten[d].zeugstatus:=0;
   bauten[d].zeug:=00;

    einheiten[b].x:=bauten[d].x-Random(50);
    einheiten[b].y:=bauten[d].y-Random(50);
    einheiten[b].xx:=einheiten[b].x + 30;
    einheiten[b].yy:=einheiten[b].y + 30;
    einheiten[b].bild:=TBitmap.Create;
einheiten[b].bild.Width:=30;
einheiten[b].bild.Height:=30;
    einheiten[b].ox:=einheiten[b].x ;
    einheiten[b].oy:=einheiten[b].y ;

    einheiten[b].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(einheiten[b].x,einheiten[b].y,einheiten[b].x+30,einheiten[b].y+30));

    einheiten[b].lx:=einheiten[b].x;
einheiten[b].ly:=einheiten[b].y;
einheiten[b].aktiv:=false;

image2.Picture.Bitmap.Width:=30+1;
image2.Picture.Bitmap.Height:=30+1;

imagelist1.draw(image2.Canvas,1,1,einheiten[b].nummer-1);
Image2.Left:=einheiten[b].x;
Image2.top :=einheiten[b].y  ;
    image1.Canvas.draw(einheiten[b].x,einheiten[b].y,image2.Picture.Bitmap);


   Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
   end;
   end;
end;

end;

procedure TForm1.FormPaint(Sender: TObject);
begin
Paintbox1.Canvas.Draw(xx,yy,Image1.Picture.Graphic);
end;

procedure TForm1.Image3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var index:TImage;
begin
index:=Sender as TImage;
if index.Tag <>0then begin
  if index.Tag = 1 then
   Label3.Caption :='Arbeitsroboter (Energie:150 Metall:100)';
  if index.Tag = 2 then
   Label3.Caption :='Hauptquartier(Energie:100 Metall:300)';
  if index.Tag = 3 then
   Label3.Caption :='Kraftwerk(Metall:400)';
  if index.Tag = 4 then
   Label3.Caption :='Panzerwerk(Energie:190 Metall:500)';
  if index.Tag = 5 then
   Label3.Caption :='Hubschrauberwerk(Energie:210 Metall:550)';
  if index.Tag = 6 then
   Label3.Caption :='Bergwerk(Energie:200 Metall:25)';
  if index.Tag = 7 then
   Label3.Caption :='Mauer(Energie:10 Metall:25)';
  if index.Tag = 20 then
   Label3.Caption :='Leichter Panzer(Energie:200 Metall:170)';
  if index.Tag = 30 then
   Label3.Caption :='Leichter Hubschrauber(Energie:250 Metall:220)';


end else Label2.Caption:='';
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Label3.Caption:='';
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var a,b,c,x,y:integer;
    akt:Boolean;
begin

for c:=1 to ein do begin
a:=c;
if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=10) then begin
         b:=254;
   x:=einheiten[a].x;
   y:=einheiten[a].y;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
               einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;

         einheiten[a].ziel :=0;
       for a:=1 to 50 do  begin
      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;
    hause:=hause+1;
    bauen( x,y,1,b,hq,Haus[1]);
end else if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=11) then begin
       b:=254;
           hause:=hause+1;
   x:=einheiten[a].x;
    y:=einheiten[a].y;
          einheiten[a].ziel :=0;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
                        einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;

       for a:=1 to 50 do  begin

      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;


    bauen( x,y,2,b,energie,Haus[2]);
     image4.Tag:=image4.Tag + 400;

  Label4.Caption :=   intTostr(image4.tag);



end else if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=12) then begin
       b:=254;
   x:=einheiten[a].x;
    y:=einheiten[a].y;
          einheiten[a].ziel :=0;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
                        einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;
           hause:=hause+1;
       for a:=1 to 50 do  begin

      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;


    bauen( x,y,3,b,pan,Haus[3]);

end else if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=13) then begin
       b:=254;
   x:=einheiten[a].x;
       hause:=hause+1;
    y:=einheiten[a].y;
          einheiten[a].ziel :=0;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
                        einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;

       for a:=1 to 50 do  begin

      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;


    bauen( x,y,4,b,hub,Haus[4]);
end else if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=14) then begin
       b:=254;
   x:=einheiten[a].x;
       hause:=hause+1;
    y:=einheiten[a].y;
          einheiten[a].ziel :=0;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
                        einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;

       for a:=1 to 50 do  begin

      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;

        hause:=hause+1;
    bauen( x,y,5,b,mela,Haus[5]);
end  else if (ABS(einheiten[a].x -einheiten[a].lx)< 5)and(ABS(einheiten[a].y -einheiten[a].ly)< 5) and (einheiten[a].ziel=15) then begin
       b:=254;
   x:=einheiten[a].x;
       hause:=hause+1;
    y:=einheiten[a].y;
          einheiten[a].ziel :=0;
            einheiten[a].delx:=0;
               einheiten[a].dely:=0;
                        einheiten[a].delxx:=0;
            einheiten[a].delyy:=0;

       for a:=1 to 50 do  begin

      if bauten[a].Typ=non then begin
         b:=a;
         break;
         end;
      end;
    if b = 254 then exit;

        hause:=hause+1;
    bauen( x,y,6,b,mauer,Haus[6]);
end;

end;

for a:=1 to 50 do begin
 for b:= 1 to 3 do begin
if bauten[a].Typ= mela then
  if (bauten[a].xx > stein[b].x) and
     (bauten[a].x < stein[b].x + elemente[2].Width) and
     (bauten[a].yy > stein[b].y) and
     (bauten[a].y < stein[b].y+ elemente[2].Height) then begin


bauten[a].zeugstatus:=bauten[a].zeugstatus + 1 ;
if bauten[a].zeugstatus >= 50then begin
image5.Tag:=image5.Tag + 30;

  Label5.Caption :=   intTostr(image5.tag);
  bauten[a].zeugstatus:=0;
end;
end;
end;
if bauten[a].Typ= energie then begin

bauten[a].zeugstatus:=bauten[a].zeugstatus + 1 ;
if bauten[a].zeugstatus >= 50then begin
image4.Tag:=image4.Tag + 30;

  Label4.Caption :=   intTostr(image4.tag);
  bauten[a].zeugstatus:=0;
end;
end;

end;
end;
procedure TForm1.animateTimer(Sender: TObject);
var a:integer;
begin
for a:= 1 to ein do begin
if einheiten[a].typ=lheli then  begin
{einheiten[a].tmp:=einheiten[a].tmp+1;
if einheiten[a].tmp >1 then einheiten[a].tmp:=0;
paintbox1.canvas.CopyRect(rect(xx+einheiten[a].ox,yy+einheiten[a].oy,xx+einheiten[a].ox+30,yy+einheiten[a].oy+30),
                einheiten[a].bild.canvas,
                rect(0,0,30,30));
imagelist1.draw(paintbox1.canvas,xx+einheiten[a].ox,yy+einheiten[a].oy,2+einheiten[a].tmp);}
end;
end;
end;

procedure TForm1.FormShow(Sender: TObject);

var
    a,b,c,x,y:integer;
begin
ia:=false;
screen.Cursors[100]:=LoadCursor(HINSTANCE,'HQ');
screen.Cursors[101]:=LoadCursor(HINSTANCE,'EN');
screen.Cursors[102]:=LoadCursor(HINSTANCE,'PAN');
screen.Cursors[103]:=LoadCursor(HINSTANCE,'HUB');
screen.Cursors[104]:=LoadCursor(HINSTANCE,'MELA');
screen.Cursors[105]:=LoadCursor(HINSTANCE,'Mauer');
Image1.Picture.Create;
Image1.Picture.Bitmap.Width:=1000;
Image1.Picture.Bitmap.Height:=800;;
Application.ProcessMessages;
paintbox1.Canvas.brush.Color := clBlack;
image1.Canvas.Pen.Color:=clRed;
boden:=Tbitmap.Create;
boden.Width:=1000;
boden.Height:=800;;

Image2.Picture.Bitmap.LoadFromFile('boden.bmp');
for a:=0to Image1.Width div 50 do
   for b:=0to Image1.Height div 50 do begin
    Image1.Canvas.Draw(a*50,b*50,Image2.Picture.Graphic);
   end;

boden.Canvas.Draw(0,0,image1.Picture.Graphic);
elemente[1]:=TBitmap.Create;
elemente[1].Width:=Image2.Width;
elemente[1].Height:=Image2.Height;
elemente[1].Canvas.Draw(0,0,Image2.Picture.Graphic);


Image2.Picture.Bitmap.LoadFromFile('steinb.bmp');

elemente[2]:=TBitmap.Create;
elemente[2].Width:=Image2.Width;
elemente[2].Height:=Image2.Height;
elemente[2].Canvas.Draw(0,0,Image2.Picture.Graphic);

Image2.Picture.Bitmap.LoadFromFile('energiel.bmp');
bau[2]:=TBitmap.Create;
bau[2].Width:=Image2.Width;
bau[2].Height:=Image2.Height;
bau[2].Canvas.Draw(0,0,Image2.Picture.Graphic);
haus[2]:=TBitmap.Create;
haus[2].Width:=Image2.Width;
haus[2].Height:=Image2.Height;
haus[2].Canvas.Draw(0,0,Image2.Picture.Graphic);

Image2.Picture.Bitmap.LoadFromFile('panzerl.bmp');
bau[3]:=TBitmap.Create;
bau[3].Width:=Image2.Width;
bau[3].Height:=Image2.Height;
bau[3].Canvas.Draw(0,0,Image2.Picture.Graphic);
haus[3]:=TBitmap.Create;
haus[3].Width:=Image2.Width;
haus[3].Height:=Image2.Height;
haus[3].Canvas.Draw(0,0,Image2.Picture.Graphic);

Image2.Picture.Bitmap.LoadFromFile('hubl.bmp');
bau[4]:=TBitmap.Create;
bau[4].Width:=Image2.Width;
bau[4].Height:=Image2.Height;
bau[4].Canvas.Draw(0,0,Image2.Picture.Graphic);
haus[4]:=TBitmap.Create;
haus[4].Width:=Image2.Width;
haus[4].Height:=Image2.Height;
haus[4].Canvas.Draw(0,0,Image2.Picture.Graphic);

Image2.Picture.Bitmap.LoadFromFile('MELA.bmp');
bau[5]:=TBitmap.Create;
bau[5].Width:=Image2.Width;
bau[5].Height:=Image2.Height;
bau[5].Canvas.Draw(0,0,Image2.Picture.Graphic);
haus[5]:=TBitmap.Create;
haus[5].Width:=Image2.Width;
haus[5].Height:=Image2.Height;
haus[5].Canvas.Draw(0,0,Image2.Picture.Graphic);


Image2.Picture.Bitmap.LoadFromFile('bhql.bmp');
bau[1]:=TBitmap.Create;
bau[1].Width:=Image2.Width;
bau[1].Height:=Image2.Height;
bau[1].Canvas.Draw(0,0,Image2.Picture.Graphic);


Image2.Picture.Bitmap.LoadFromFile('hql.bmp');

haus[1]:=TBitmap.Create;
haus[1].Width:=Image2.Width;
haus[1].Height:=Image2.Height;
haus[1].Canvas.Draw(0,0,Image2.Picture.Graphic);


Image2.Picture.Bitmap.LoadFromFile('mauer.bmp');
bau[6]:=TBitmap.Create;
bau[6].Width:=Image2.Width;
bau[6].Height:=Image2.Height;
bau[6].Canvas.Draw(0,0,Image2.Picture.Graphic);
haus[6]:=TBitmap.Create;
haus[6].Width:=Image2.Width;
haus[6].Height:=Image2.Height;
haus[6].Canvas.Draw(0,0,Image2.Picture.Graphic);




Memo1.Lines.LoadFromFile('lev1.dat');
Image4.Tag :=StrToInt(Memo1.Lines.Strings[0]);
Label4.Caption:=Memo1.Lines.Strings[0];
Image5.Tag :=StrToInt(Memo1.Lines.Strings[1]);
Label5.Caption :=Memo1.Lines.Strings[1];
c:=2;
repeat
if
Memo1.Lines.Strings[c]='st' then begin
x:= StrToInt(Memo1.Lines.Strings[c+2]);
y:= StrToInt(Memo1.Lines.Strings[c+3]);
b:=StrToInt(Memo1.Lines.Strings[c+1]);
image2.Picture.Bitmap.Width:=elemente[2].Width+1;
image2.Picture.Bitmap.Height:=elemente[2].Height+1;
image2.Canvas.draw(0,0,elemente[2]);
Image2.Left:=x;
Image2.top:=y  ;


image1.Canvas.Draw(x,y,image2.Picture.Graphic);
stein[b].x:=x;
stein[b].y:=y;
c:=c+3;
end else if Memo1.Lines.Strings[c]='hq' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
zeugen(x,y,1,b,hq);
c:=c+3;
inc(hause);
end else if Memo1.Lines.Strings[c]='MELA' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
zeugen(x,y,5,b,Mela);
inc(hause);
c:=c+3;
end else if Memo1.Lines.Strings[c]='en' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
inc(hause);
zeugen(x,y,2,b,energie);
c:=c+3;
end else if Memo1.Lines.Strings[c]='hub' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
zeugen(x,y,4,b,hub);

inc(hause);
c:=c+3;
end else if Memo1.Lines.Strings[c]='pan' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
zeugen(x,y,3,b,pan);
c:=c+3;
inc(hause);
end else if Memo1.Lines.Strings[c]='arrob' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
inc(ein);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
einheiten[b].Typ:=arrob;
einheiten[b].x:=x;
einheiten[b].ox:=x;
einheiten[b].oy:=y;

einheiten[b].y:=y;
einheiten[b].lx:=x;
einheiten[b].ly:=y;
einheiten[b].xx:=x + 30;
einheiten[b].yy:=y+ 30;
einheiten[b].nummer:=1;
einheiten[b].bild:=TBitmap.Create;
einheiten[b].bild.Width:=30;
einheiten[b].bild.Height:=30;
einheiten[b].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(einheiten[b].x,einheiten[b].y,einheiten[b].x+30,einheiten[b].y+30));

end else if Memo1.Lines.Strings[c]='lpan' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
einheiten[b].Typ:=lpan;
einheiten[b].x:=x;
einheiten[b].y:=y;
einheiten[b].ox:=x;
einheiten[b].oy:=y;

einheiten[b].lx:=x;
inc(ein);
einheiten[b].ly:=y;
einheiten[b].xx:=x + 30;
einheiten[b].yy:=y+ 30;
einheiten[b].nummer:=2;
einheiten[b].bild:=TBitmap.Create;
einheiten[b].bild.Width:=30;
einheiten[b].bild.Height:=30;
einheiten[b].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(einheiten[b].x,einheiten[b].y,einheiten[b].x+30,einheiten[b].y+30));

end else if Memo1.Lines.Strings[c]='lheli' then begin
b:=StrToInt(Memo1.Lines.Strings[c+1]);
x:=StrToInt(Memo1.Lines.Strings[c+2]);
y:=StrToInt(Memo1.Lines.Strings[c+3]);
einheiten[b].Typ:=lheli;
einheiten[b].x:=x;
einheiten[b].y:=y;
einheiten[b].ox:=x;
einheiten[b].oy:=y;

einheiten[b].lx:=x;
einheiten[b].ly:=y;
einheiten[b].xx:=x + 30;
inc(ein);
einheiten[b].yy:=y+ 30;
einheiten[b].nummer:=3;
einheiten[b].bild:=TBitmap.Create;
einheiten[b].bild.Width:=30;
einheiten[b].bild.Height:=30;
einheiten[b].bild.canvas.CopyRect(rect(0,0,30,30),
                image1.canvas,
                rect(einheiten[b].x,einheiten[b].y,einheiten[b].x+30,einheiten[b].y+30));

end;
c:=c+1;
until c>=Memo1.Lines.Count -1;
akt;

end;

end.
